# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

## 2022-12-13

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_authentication_bloc` - `v0.4.1`](#wyatt_authentication_bloc---v041)

---

#### `wyatt_authentication_bloc` - `v0.4.1`

 - **REFACTOR**: use fromFirebaseUser factory to parse user.
 - **REFACTOR**: update deps and re-export them.
 - **FIX**: fix mock on register.
 - **FEAT**: add google sign in in signIn cubit.
 - **FEAT**: add google sign in parameter in firebase data source constructor.
 - **FEAT**: add google sign_in support (closes #59).
 - **FEAT**: add reauthenticate, updateEmail and updatePassword.
 - **DOCS**: add correct header.


## 2022-12-12

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_analysis` - `v2.3.0`](#wyatt_analysis---v230)

---

#### `wyatt_analysis` - `v2.3.0`

 - **REFACTOR**: follow melos versioning.
 - **FIX**: change file include to keep coherence.
 - **FEAT**: exclude generated code, and add dart>2.16 rules.
 - **FEAT**: add overwrite protection.
 - **FEAT**: add 2.2.2 files for archive.
 - **FEAT**: add utils script to easely bump version.


## 2022-12-04

### Changes

---

Packages with breaking changes:

 - [`wyatt_bloc_helper` - `v2.0.0`](#wyatt_bloc_helper---v200)

Packages with other changes:

 - [`wyatt_type_utils` - `v0.0.4`](#wyatt_type_utils---v004)
 - [`wyatt_authentication_bloc` - `v0.4.0+3`](#wyatt_authentication_bloc---v0403)
 - [`wyatt_crud_bloc` - `v0.1.0+2`](#wyatt_crud_bloc---v0102)
 - [`wyatt_architecture` - `v0.1.0+1`](#wyatt_architecture---v0101)
 - [`wyatt_form_bloc` - `v0.2.0+2`](#wyatt_form_bloc---v0202)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.4.0+3`
 - `wyatt_crud_bloc` - `v0.1.0+2`
 - `wyatt_architecture` - `v0.1.0+1`
 - `wyatt_form_bloc` - `v0.2.0+2`

---

#### `wyatt_bloc_helper` - `v2.0.0`

 - **BREAKING** **REFACTOR**: update onWrap label (close #46).

#### `wyatt_type_utils` - `v0.0.4`

 - **FEAT**: add Result extension on FutureOr type (close #40).


## 2022-12-03

### Changes

---

Packages with breaking changes:

 - [`wyatt_architecture` - `v0.1.0`](#wyatt_architecture---v010)

Packages with other changes:

 - [`wyatt_authentication_bloc` - `v0.4.0+2`](#wyatt_authentication_bloc---v0402)
 - [`wyatt_crud_bloc` - `v0.1.0+1`](#wyatt_crud_bloc---v0101)
 - [`wyatt_form_bloc` - `v0.2.0+1`](#wyatt_form_bloc---v0201)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.4.0+2`
 - `wyatt_crud_bloc` - `v0.1.0+1`
 - `wyatt_form_bloc` - `v0.2.0+1`

---

#### `wyatt_architecture` - `v0.1.0`

 - **REFACTOR**: update naming methodes (close #47).
 - **REFACTOR**: update example. (close #38).
 - **FIX**: fix execute method on error handler. (#38).
 - **FEAT**: update usecase en add  &  sepcific case. (#38).
 - **FEAT**: add obsevers for alternative usecase scenarions (#38).
 - **DOCS**: generate class model. (#38).
 - **DOCS**: update Readme. (#38).
 - **BREAKING** **CHORE**: update exports. (#38).


## 2022-11-16

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_authentication_bloc` - `v0.4.0+1`](#wyatt_authentication_bloc---v0401)

---

#### `wyatt_authentication_bloc` - `v0.4.0+1`

 - **FIX**: add sort of mutex on onAuthChanges callback trigger.


## 2022-11-16

### Changes

---

Packages with breaking changes:

 - [`wyatt_authentication_bloc` - `v0.4.0`](#wyatt_authentication_bloc---v040)
 - [`wyatt_form_bloc` - `v0.2.0`](#wyatt_form_bloc---v020)

Packages with other changes:

 - There are no other changes in this release.

---

#### `wyatt_authentication_bloc` - `v0.4.0`

 - **REFACTOR**: update example with new input builders.
 - **FIX**: add initial null account event in stream in the mock authentication.
 - **BREAKING** **FIX**: add signInWithEmailAndPassword and signInAnonymously methods in SignInCubit #26.

#### `wyatt_form_bloc` - `v0.2.0`

 - **FIX**: disable status selection and rebuild SubmitBuilder on every state changes #28.
 - **FIX**: fix set operations behaviors.
 - **FIX**: add nullable validator on boolean value.
 - **FEAT**: add metadata tag to bypass validation #29.
 - **FEAT**: add shorthands to access validator status.
 - **BREAKING** **REFACTOR**: input builders provides FormInput.


## 2022-11-13

### Changes

---

Packages with breaking changes:

 - [`wyatt_crud_bloc` - `v0.1.0`](#wyatt_crud_bloc---v010)

Packages with other changes:

 - There are no other changes in this release.

---

#### `wyatt_crud_bloc` - `v0.1.0`

 - **REFACTOR**: add vscode config.
 - **FIX**: update example.
 - **BREAKING** **REFACTOR**: migrate to wyatt architecture.


## 2022-11-11

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_authentication_bloc` - `v0.3.0+1`](#wyatt_authentication_bloc---v0301)

---

#### `wyatt_authentication_bloc` - `v0.3.0+1`

 - **FIX**: fix some bugs to validate publishing.


## 2022-11-11

### Changes

---

Packages with breaking changes:

 - [`wyatt_authentication_bloc` - `v0.3.0`](#wyatt_authentication_bloc---v030)

Packages with other changes:

 - There are no other changes in this release.

---

#### `wyatt_authentication_bloc` - `v0.3.0`

 - **REFACTOR**: use correct deps.
 - **REFACTOR**: update example with new listeners.
 - **FIX**: return exception and not throwing it anymore.
 - **FIX**: exception returns msg as message.
 - **FEAT**: add fully functionnal mock data source.
 - **FEAT**: add toString and equality on entities and models.
 - **BREAKING** **FEAT**: add email verification, password reset support.


## 2022-11-10

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_architecture` - `v0.0.2`](#wyatt_architecture---v002)
 - [`wyatt_authentication_bloc` - `v0.2.1+6`](#wyatt_authentication_bloc---v0216)
 - [`wyatt_form_bloc` - `v0.1.0+1`](#wyatt_form_bloc---v0101)

Packages graduated to a stable release (see pre-releases prior to the stable version for changelog entries):

 - `wyatt_architecture` - `v0.0.2`

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.2.1+6`
 - `wyatt_form_bloc` - `v0.1.0+1`

---

#### `wyatt_architecture` - `v0.0.2`


## 2022-11-10

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_form_bloc` - `v0.1.0`](#wyatt_form_bloc---v010)
 - [`wyatt_authentication_bloc` - `v0.2.1+5`](#wyatt_authentication_bloc---v0215)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.2.1+5`

---

#### `wyatt_form_bloc` - `v0.1.0`

 - **REFACTOR**: refactor simple example.
 - **FIX**: make cubit custom implementation simpler.
 - **FEAT**: clean and add toString and equality.


## 2022-11-08

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_architecture` - `v0.0.2-dev.0`](#wyatt_architecture---v002-dev0)

---

#### `wyatt_architecture` - `v0.0.2-dev.0`

 - **FEAT**: add exceptions, datasources, repositories, and usecases.


## 2022-11-07

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_type_utils` - `v0.0.3+1`](#wyatt_type_utils---v0031)
 - [`wyatt_architecture` - `v0.0.1+2`](#wyatt_architecture---v0012)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_architecture` - `v0.0.1+2`

---

#### `wyatt_type_utils` - `v0.0.3+1`

 - **REFACTOR**: rename future result extension.


## 2022-11-06

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_bloc_helper` - `v1.2.0`](#wyatt_bloc_helper---v120)

---

#### `wyatt_bloc_helper` - `v1.2.0`

 - **REFACTOR**: general code update.
 - **FEAT**: add init function and multi provider.
 - **FEAT**: add a lot of docs, fix `onWrap`, and add repo provider.
 - **FEAT**: add wrap feature.
 - **DOCS**: add ios example.
 - **DOCS**: update license.


## 2022-11-06

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_type_utils` - `v0.0.3`](#wyatt_type_utils---v003)
 - [`wyatt_architecture` - `v0.0.1+1`](#wyatt_architecture---v0011)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_architecture` - `v0.0.1+1`

---

#### `wyatt_type_utils` - `v0.0.3`

 - **REFACTOR**: move either folder.
 - **FEAT**: add object, string, datetime, iterable extensions.
 - **FEAT**: add new pair type.


## 2022-11-06

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_analysis` - `v2.2.2`](#wyatt_analysis---v222)

---

#### `wyatt_analysis` - `v2.2.2`

 - **DOCS**: add publish_to self hosted pub server.


## 2022-08-26

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_form_bloc` - `v0.0.6`](#wyatt_form_bloc---v006)
 - [`wyatt_authentication_bloc` - `v0.2.1+4`](#wyatt_authentication_bloc---v0214)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.2.1+4`

---

#### `wyatt_form_bloc` - `v0.0.6`

 - **FEAT**: add raw form validator.


## 2022-08-25

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_form_bloc` - `v0.0.5`](#wyatt_form_bloc---v005)
 - [`wyatt_authentication_bloc` - `v0.2.1+3`](#wyatt_authentication_bloc---v0213)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.2.1+3`

---

#### `wyatt_form_bloc` - `v0.0.5`

 - **FEAT**: update deps.


## 2022-08-25

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_form_bloc` - `v0.0.4`](#wyatt_form_bloc---v004)
 - [`wyatt_authentication_bloc` - `v0.2.1+2`](#wyatt_authentication_bloc---v0212)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.2.1+2`

---

#### `wyatt_form_bloc` - `v0.0.4`

 - **FEAT**: add form validator class with strategy design pattern.


## 2022-07-18

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_type_utils` - `v0.0.2`](#wyatt_type_utils---v002)

---

#### `wyatt_type_utils` - `v0.0.2`

 - **FEAT**: add strongly typed Option and Result.
 - **FEAT**: add mason generated package.
 - **DOCS**: remove useless web example.


## 2022-07-12

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_analysis` - `v2.2.1`](#wyatt_analysis---v221)

---

#### `wyatt_analysis` - `v2.2.1`

 - **FIX**: import right version.


## 2022-07-11

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_analysis` - `v2.2.0`](#wyatt_analysis---v220)

---

#### `wyatt_analysis` - `v2.2.0`

 - **FIX**: rename to follow melos versioning and remove redundant rule.
 - **FEAT**: promote experimental, update analyzer rules and add some linter rules.


## 2022-07-10

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`form_bloc_example` - `v1.1.0`](#form_bloc_example---v110)
 - [`wyatt_form_bloc` - `v0.0.3`](#wyatt_form_bloc---v003)
 - [`authentication_bloc_example` - `v1.0.1`](#authentication_bloc_example---v101)
 - [`wyatt_authentication_bloc` - `v0.2.1+1`](#wyatt_authentication_bloc---v0211)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `authentication_bloc_example` - `v1.0.1`
 - `wyatt_authentication_bloc` - `v0.2.1+1`

---

#### `form_bloc_example` - `v1.1.0`

 - **FEAT**: add list option validator.
 - **DOCS**: add example app.

#### `wyatt_form_bloc` - `v0.0.3`

 - **FEAT**: add helpers.
 - **FEAT**: add metadata on inputs.
 - **FEAT**: update to latest dart version.


## 2022-06-24

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_http_client` - `v1.2.0`](#wyatt_http_client---v120)

---

#### `wyatt_http_client` - `v1.2.0`

 - **FEAT**: add new middleware feature.
 - **FEAT**: implements doublelinked list for middlewares.
 - **FEAT**: [WIP] implements middleware system.
 - **FEAT**: [WIP] work on middleware feature.


## 2022-05-23

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_http_client` - `v1.1.0`](#wyatt_http_client---v110)

---

#### `wyatt_http_client` - `v1.1.0`

 - **FEAT**: add oauth2 refresh token client.


## 2022-05-23

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_analysis` - `v2.1.0`](#wyatt_analysis---v210)

---

#### `wyatt_analysis` - `v2.1.0`

 - **FEAT**: add experimental rules in appropriate file.


## 2022-05-20

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_authentication_bloc` - `v0.2.1`](#wyatt_authentication_bloc---v021)
 - [`wyatt_bloc_helper` - `v1.1.0`](#wyatt_bloc_helper---v110)

---

#### `wyatt_authentication_bloc` - `v0.2.1`

 - **FEAT**: add google, facebook, apple, twitter login.

#### `wyatt_bloc_helper` - `v1.1.0`

 - **FEAT**: add provider, consumer and helpers.


## 2022-05-05

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_medium_feeds` - `v1.0.1`](#wyatt_medium_feeds---v101)

---

#### `wyatt_medium_feeds` - `v1.0.1`

 - **FIX**: remove useless example file.


## 2022-05-02

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_form_bloc` - `v0.0.2`](#wyatt_form_bloc---v002)
 - [`wyatt_authentication_bloc` - `v0.2.0+1`](#wyatt_authentication_bloc---v0201)

Packages with dependency updates only:

> Packages listed below depend on other packages in this workspace that have had changes. Their versions have been incremented to bump the minimum dependency versions of the packages they depend upon in this project.

 - `wyatt_authentication_bloc` - `v0.2.0+1`

---

#### `wyatt_form_bloc` - `v0.0.2`

 - **FEAT**: add list option validator.


## 2022-04-20

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_crud_bloc` - `v0.0.2`](#wyatt_crud_bloc---v002)
 - [`wyatt_analysis` - `v2.0.1`](#wyatt_analysis---v201)

---

#### `wyatt_crud_bloc` - `v0.0.2`

 - Migrate crud_package in monorepo

 - **DOCS**: add example app.

#### `wyatt_analysis` - `v2.0.1`

 - **DOCS**: Update readme with new version.


## 2022-04-20

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_authentication_bloc` - `v0.2.0`](#wyatt_authentication_bloc---v020)

Packages graduated to a stable release (see pre-releases prior to the stable version for changelog entries):

 - `wyatt_authentication_bloc` - `v0.2.0`

---

#### `wyatt_authentication_bloc` - `v0.2.0`


## 2022-04-20

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_form_bloc` - `v0.0.1`](#wyatt_form_bloc---v001)

Packages graduated to a stable release (see pre-releases prior to the stable version for changelog entries):

 - `wyatt_form_bloc` - `v0.0.1`

---

#### `wyatt_form_bloc` - `v0.0.1`


## 2022-04-20

### Changes

---

Packages with breaking changes:

 - There are no breaking changes in this release.

Packages with other changes:

 - [`wyatt_form_bloc` - `v0.0.1-dev.0`](#wyatt_form_bloc---v001-dev0)

---

#### `wyatt_form_bloc` - `v0.0.1-dev.0`

 - **REFACTOR**: all package structure/documentation.
 - **FEAT**: new utility package for forms and bloc.
 - **DOCS**: add example app.
 - **DOCS**: add few project files.


## 2022-04-19

### Changes

---

Packages with breaking changes:

 - [`wyatt_authentication_bloc` - `v0.2.0-dev.0`](#wyatt_authentication_bloc---v020-dev0)

Packages with other changes:

 - There are no other changes in this release.

---

#### `wyatt_authentication_bloc` - `v0.2.0-dev.0`

 - **BREAKING** **FEAT**: rename package.


## 2022-04-19

### Changes

---

Packages with breaking changes:

 - [`wyatt_analysis` - `v2.0.0`](#wyatt_analysis---v200)

Packages with other changes:

 - There are no other changes in this release.

---

#### `wyatt_analysis` - `v2.0.0`

 - **BREAKING** **FIX**: remove unawaited() since its in Dart 2.15.

