// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'album_bloc.dart';

class AlbumState extends Equatable {
  const AlbumState({
    this.status = FetchStatus.initial,
    this.albums = const <Album>[],
    this.hasReachedMax = false,
  });

  final FetchStatus status;
  final List<Album> albums;
  final bool hasReachedMax;

  AlbumState copyWith({
    FetchStatus? status,
    List<Album>? albums,
    bool? hasReachedMax,
  }) =>
      AlbumState(
        status: status ?? this.status,
        albums: albums ?? this.albums,
        hasReachedMax: hasReachedMax ?? this.hasReachedMax,
      );

  @override
  List<Object> get props => [status, albums, hasReachedMax];
}
