// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'photo_details_cubit.dart';

abstract class PhotoDetailsState extends Equatable {
  const PhotoDetailsState();

  @override
  List<Object> get props => [];
}

class PhotoDetailsInitial extends PhotoDetailsState {}

class PhotoDetailsSuccess extends PhotoDetailsState {

  const PhotoDetailsSuccess(this.photo, {required this.isFavorite});
  final Photo photo;
  final bool isFavorite;

  @override
  List<Object> get props => [photo, isFavorite];
}

class PhotoDetailsFailure extends PhotoDetailsState {

  const PhotoDetailsFailure(this.error);
  final String error;

  @override
  List<Object> get props => [error];
}
