// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'dart:async';

import 'package:architecture_example/domain/usecases/photos/check_if_photo_is_in_favorites.dart';
import 'package:equatable/equatable.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

part 'favorite_checker_state.dart';

class FavoriteCheckerCubit extends Cubit<FavoriteCheckerState> {

  FavoriteCheckerCubit(this._checkIfPhotoIsInFavorites)
      : super(FavoriteCheckerInitial());
  final CheckIfPhotoIsInFavorites _checkIfPhotoIsInFavorites;

  FutureOr<void> checkIfPhotoIsInFavorites(int photoId) async {
    final response = await _checkIfPhotoIsInFavorites.call(photoId);
    emit(
      response.fold(
        (value) => FavoriteCheckerSuccess(photoId, isFavorite: value),
        (error) => FavoriteCheckerFailure(error.toString()),
      ),
    );
  }
}
