// ignore_for_file: public_member_api_docs, sort_constructors_first
// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_authentication_bloc/wyatt_authentication_bloc.dart';

class AccountModelFirebase extends AccountModel {
  AccountModelFirebase._({
    required super.uid,
    required super.emailVerified,
    required super.isAnonymous,
    required super.providerId,
    super.lastSignInTime,
    super.creationTime,
    super.isNewUser,
    super.email,
    super.phoneNumber,
    super.photoURL,
  });

  factory AccountModelFirebase.fromFirebaseUser(User? user) {
    if (user != null) {
      return AccountModelFirebase._(
        uid: user.uid,
        emailVerified: user.emailVerified,
        isAnonymous: user.isAnonymous,
        providerId: user.providerData.first.providerId,
        creationTime: user.metadata.creationTime,
        lastSignInTime: user.metadata.lastSignInTime,
        isNewUser: (user.metadata.creationTime != null &&
                user.metadata.lastSignInTime != null)
            ? user.metadata.lastSignInTime! == user.metadata.creationTime!
            : null,
        email: user.email,
        phoneNumber: user.phoneNumber,
        photoURL: user.photoURL,
      );
    } else {
      throw ModelParsingFailureFirebase('null-user', 'User cannot be null!');
    }
  }
}
