// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'authentication_cubit.dart';

class AuthenticationState<Extra> extends Equatable {
  const AuthenticationState.unauthenticated()
      : this._(status: AuthenticationStatus.unauthenticated);

  const AuthenticationState.authenticated(AccountWrapper<Extra> accountWrapper)
      : this._(
          status: AuthenticationStatus.authenticated,
          accountWrapper: accountWrapper,
        );

  const AuthenticationState.unknown()
      : this._(status: AuthenticationStatus.unknown);

  const AuthenticationState._({required this.status, this.accountWrapper});
  final AuthenticationStatus status;
  final AccountWrapper<Extra>? accountWrapper;

  @override
  List<Object?> get props => [status, accountWrapper];

  @override
  String toString() =>
      'AuthenticationState(status: $status, accountWrapper: $accountWrapper)';
}
