// ignore_for_file: public_member_api_docs, sort_constructors_first
// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'email_verification_cubit.dart';

class EmailVerificationState extends Equatable {
  final FormStatus status;
  final bool isVerified;
  final String? errorMessage;

  const EmailVerificationState({
    this.isVerified = false,
    this.status = FormStatus.pure,
    this.errorMessage,
  });

  EmailVerificationState copyWith({
    FormStatus? status,
    bool? isVerified,
    String? errorMessage,
  }) =>
      EmailVerificationState(
        status: status ?? this.status,
        isVerified: isVerified ?? this.isVerified,
        errorMessage: errorMessage ?? this.errorMessage,
      );

  @override
  List<Object?> get props => [status, isVerified, errorMessage];

  @override
  String toString() => 'EmailVerificationState(status: ${status.name} '
      '${(errorMessage != null) ? " [$errorMessage]" : ""}, '
      'isVerified: $isVerified)';
}
