// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_architecture/wyatt_architecture.dart';
import 'package:wyatt_crud_bloc/src/core/enums/where_query_type.dart';

// ignore: one_member_abstracts
abstract class QueryParser<Q> {
  Q parser(QueryInterface condition, Q query);
}

abstract class QueryInterface extends Entity {}

class WhereQuery<Value> extends QueryInterface {

  WhereQuery(this.type, this.field, this.value);
  final WhereQueryType type;
  final String field;
  final Value value;
}

class LimitQuery extends QueryInterface {

  LimitQuery(this.limit);
  final int limit;
}

class OrderByQuery extends QueryInterface {

  OrderByQuery(this.field, {this.ascending = true});
  final String field;
  final bool ascending;
}
