// ignore_for_file: public_member_api_docs, sort_constructors_first
// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'dart:async';

import 'package:wyatt_architecture/wyatt_architecture.dart';
import 'package:wyatt_crud_bloc/src/domain/entities/object_model.dart';
import 'package:wyatt_crud_bloc/src/domain/repositories/crud_repository.dart';

class Create<Model extends ObjectModel> extends AsyncUseCase<Model, void> {
  final CrudRepository<Model> _crudRepository;

  Create(this._crudRepository);

  @override
  FutureOr<void> onStart(Model? params) {
    if (params == null) {
      throw ClientException('$Model cannot be null.');
    }
  }

  @override
  FutureOrResult<void> execute(Model? params) =>
      _crudRepository.create(params!);
}
