// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:form_bloc_example/app/metadata.dart';
import 'package:form_bloc_example/constants.dart';
import 'package:form_bloc_example/simple_custom_form_cubit/simple_custom_form_cubit.dart';
import 'package:wyatt_form_bloc/wyatt_form_bloc.dart';

class _NameInput extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return InputBuilderTextController<SimpleCustomFormCubit, String?, Metadata>(
      field: formFieldName,
      builder: (context, cubit, state, field, input, controller, metadata) {
        return TextField(
          controller: controller,
          onChanged: (value) => cubit.dataChanged(field, Name.dirty(value)),
          keyboardType: TextInputType.name,
          decoration: InputDecoration(
            labelText: 'name',
            helperText: '',
            errorText: input.validator.invalid ? 'invalid name' : null,
          ),
        );
      },
    );
  }
}

class SimpleSignUpForm extends StatelessWidget {
  const SimpleSignUpForm({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        _NameInput(),
        const SizedBox(height: 8),
      ],
    );
  }
}
