// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_form_bloc/src/data/form_operations/form_difference.dart';
import 'package:wyatt_form_bloc/src/data/form_operations/form_intersection.dart';
import 'package:wyatt_form_bloc/src/data/form_operations/form_replace.dart';
import 'package:wyatt_form_bloc/src/data/form_operations/form_union.dart';
import 'package:wyatt_form_bloc/src/domain/form_operations/form_operation.dart';

enum SetOperation {
  /// Replace entire set with new set.
  replace(FormReplace()),

  /// Keep common elements between sets.
  intersection(FormIntersection()),

  /// Remove common elements between sets.
  difference(FormDifference()),

  /// Add new elements to set.
  union(FormUnion());

  final FormOperation operation;

  const SetOperation(this.operation);
}
