// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'form_data_cubit_impl.dart';

class FormDataStateImpl extends FormDataState {
  const FormDataStateImpl({
    required super.form,
    super.status = FormStatus.pure,
    super.errorMessage,
  });

  FormDataStateImpl copyWith({
    FormStatus? status,
    WyattForm? form,
    String? errorMessage,
  }) =>
      FormDataStateImpl(
        status: status ?? this.status,
        form: form ?? this.form,
        errorMessage: errorMessage ?? this.errorMessage,
      );

  @override
  List<Object?> get props => [status, form, errorMessage];

  @override
  String toString() => 'FormDataSate(status: ${status.name} '
      '${(errorMessage != null) ? " [$errorMessage]" : ""}, $form)';
}
