// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:wyatt_form_bloc/wyatt_form_bloc.dart';

class InputBuilder<Cubit extends FormDataCubit> extends StatelessWidget {
  const InputBuilder({required this.field, required this.builder, super.key});

  final String field;

  final Widget Function(
    BuildContext context,
    Cubit cubit,
    FormDataState state,
    String field,
    FormInput<dynamic, FormInputValidator<dynamic, ValidationError>, dynamic>
        input,
  ) builder;

  @override
  Widget build(BuildContext context) => BlocBuilder<Cubit, FormDataState>(
        builder: (context, state) {
          final cubit = context.watch<Cubit>();
          final input = state.form.inputOf(field);
          return builder.call(context, cubit, state, field, input);
        },
      );
}
