// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:wyatt_form_bloc/src/core/enums/form_status.dart';
import 'package:wyatt_form_bloc/src/presentation/features/form_data/form_data_cubit.dart';

class SubmitBuilder<Cubit extends FormDataCubit> extends StatelessWidget {
  const SubmitBuilder({required this.builder, super.key});

  final Widget Function(BuildContext context, Cubit cubit, FormStatus status)
      builder;

  @override
  Widget build(BuildContext context) => BlocBuilder<Cubit, FormDataState>(
        builder: (context, state) => builder.call(
          context,
          context.read<Cubit>(),
          state.status,
        ),
      );
}
